/*
Napisimo funkciju koja ispisuje:
    1)i-ti redak matrice
    2)j-ti stupac matrice
    3)glavnu dijagonalu matrice
    4)sporednu dijagonalu
    5)elemente na pravcima koji su paralelni glavnoj
        dijagonali i prolaze tockom (a,b)
    6)elemente na pravcima koji su paralelni sporednoj
        dijagonali i prolaze tockom (a,b)
za kvadratnu matricu nxn.
*/

#include <stdio.h>

//ispis matrice
void ispis(int x[], int maxj, int n)
{
    int i, j;

    for(i=0; i<n; i++){
        for(j=0; j<n; j++){
            printf("%d ", *(x+i*maxj+j));
        }
        printf("\n");
    }
    printf("\n");
}

//(1)
void ispis_redak(int x[], int maxj, int n, int i)
{
    int j;

    printf("(1): ");
    for(j=0; j<n; j++)
        printf("%d ", x[i*maxj+j]);
    printf("\n");
}

//(2)
void ispis_stupac(int x[], int maxj, int n, int j)
{
    int i;

    printf("(2):\n");
    for(i=0; i<n; i++)
        printf("%d\n", x[i*maxj+j]);
}

//(3)
void ispis_dijag(int x[], int maxj, int n)
{
    int i;

    printf("(3): ");
    for(i=0; i<n; i++)
        printf("%d ", x[i*maxj+i]);
    printf("\n");
}

//(4)
void ispis_spdijag(int x[], int maxj, int n)
{
    int i;

    printf("(4): ");
    for(i=0; i<n; i++)
        printf("%d ", x[i*maxj+n-1-i]);
    printf("\n");
}

//(5)
void ispis_paral_dijag(int x[], int maxj, int n, int a, int b)
{
    int i;

    printf("(5): ");
    for(i=(0>a-b)?0:a-b; i<=((n-1>a-b+n-1)?a-b+n-1:n-1); i++)
        printf("%d ", x[i*maxj+i+b-a]);
    printf("\n");
}

int main(void)
{
    int x[][3]={{1,2,3},{4,5,6},{7,8,9}}, n;

    n=sizeof(x)/sizeof(*x);

    ispis((int*)x,3,n);
    ispis_redak((int*)x,3,n,2);
    ispis_stupac((int*)x,3,n,1);
    ispis_dijag((int*)x,3,n);
    ispis_spdijag((int*)x,3,n);
    ispis_paral_dijag((int*)x,3,n,2,1);

    return 0;
}
